\def\imgpath{content/methodology/algorithm/images}
\def\large{0.2\textwidth}
\def\medium{0.15\textwidth}
\def\small{0.1\textwidth}
\def\mini{0.05\textwidth}
\begin{tikzpicture}[node distance=2cm]
    %% Training process -------------------------------------------------------
    \node (training) [startstop] {Training};
    \node (audio_t) [
        io, below of=training, xshift=-\small, yshift=-\mini
    ]{
        Audio\\
        \includegraphics[width=\medium]{\imgpath/original-audio.png}
    };
    \draw [arrow] (training) -- (audio_t);
    \node (filtered_t) [process, below of=audio_t, yshift=-\small]{
        Pre-emphasis\\
        \includegraphics[width=\medium]{\imgpath/filtered-audio.png}
    };
    \draw [arrow] (audio_t) -- (filtered_t);
    \node (framed_t) [process, below of=filtered_t, yshift=-\mini]{
        Windowing\\
        \includegraphics[width=\medium]{\imgpath/framed-audio.png}
    };
    \draw [arrow] (filtered_t) -- (framed_t);
    \node (mfcc_t) [process, below of=framed_t, yshift=-\small]{
        MFCC feature extraction\\
        \includegraphics[width=\large]{\imgpath/mfcc.png}
    };
    \draw [arrow] (framed_t) -- (mfcc_t);
    \node (clusters_t) [process, below of=mfcc_t, yshift=-\small]{
        K-means clustering\\
        \includegraphics[width=\large]{\imgpath/clustered-mfcc.png}
    };
    \draw [arrow] (mfcc_t) -- (clusters_t);
    \node (identification_t) [process, right of=clusters_t, xshift=\medium]{
        Identification\\
        \includegraphics[width=\large]{\imgpath/identification-audio.png}
    };
    \draw [arrow] (clusters_t) -- (identification_t);

    \node (dictionary) [result, above of=identification_t, yshift=\large]{
        Dictionary
    };
    \draw [arrow] (identification_t) -- (dictionary);

    \node (phonemes) [io, above of=dictionary, yshift=\large] {Phonemes};
    \draw [arrow] (training) -- (phonemes);
    \draw [arrow] (phonemes) -- (dictionary);

    %% Validation process -----------------------------------------------------
    \node (validation) [startstop, right of=training, xshift=0.5\textwidth]{
        Testing
    };
    \node (audio_v) [
        io, below of=validation, yshift=-\mini
    ]{
        Audio\\
        \includegraphics[width=\medium]{\imgpath/original-audio.png}
    };
    \draw [arrow] (validation) -- (audio_v);
    \node (filtered_v) [process, below of=audio_v, yshift=-\small]{
        Pre-Emphasis\\
        \includegraphics[width=\medium]{\imgpath/filtered-audio.png}
    };
    \draw [arrow] (audio_v) -- (filtered_v);
    \node (framed_v) [process, below of=filtered_v, yshift=-\mini]{
        Windowing\\
        \includegraphics[width=\medium]{\imgpath/framed-audio.png}
    };
    \draw [arrow] (filtered_v) -- (framed_v);
    \node (mfcc_v) [process, below of=framed_v, yshift=-\small]{
        MFCC feature extraction\\
        \includegraphics[width=\large]{\imgpath/mfcc.png}
    };
    \draw [arrow] (framed_v) -- (mfcc_v);
    \node (identification_v) [process, below of=mfcc_v, yshift=-\small]{
        Identification\\
        \includegraphics[width=\large]{\imgpath/identification-audio.png}
    };
    \draw [arrow] (dictionary) -- (identification_v);
    \draw [arrow] (mfcc_v) -- (identification_v);

    \node (phonemes_v) [result, below of=identification_v, yshift=-\mini] {
        Phonemes
    };
    \draw [arrow] (identification_v) -- (phonemes_v);

\end{tikzpicture}